diff -Naru ../ppp-2.4.5/pppd/auth.c ./pppd/auth.c
--- ../ppp-2.4.5/pppd/auth.c	2019-01-10 23:58:40.693572894 +0100
+++ ./pppd/auth.c	2019-01-10 23:43:03.184630831 +0100
@@ -247,6 +247,7 @@
 bool explicit_user = 0;		/* Set if "user" option supplied */
 bool explicit_passwd = 0;	/* Set if "password" option supplied */
 char remote_name[MAXNAMELEN];	/* Peer's name for authentication */
+bool explicit_myip = 0;
 #ifdef USE_EAPTLS
 char *cacert_file  = NULL;	/* CA certificate file (pem format) */
 char *cert_file    = NULL;	/* client certificate file (pem format) */
@@ -394,6 +395,10 @@
       "Set name for auth with peer", OPT_PRIO | OPT_STATIC,
       &explicit_user, MAXNAMELEN },
 
+    { "myip", o_string, myip,
+      "Set server ip", OPT_PRIO | OPT_STATIC,
+      &explicit_myip, MAXNAMELEN },
+
     { "password", o_string, passwd,
       "Password for authenticating us to the peer",
       OPT_PRIO | OPT_STATIC | OPT_HIDE,
diff -Naru ../ppp-2.4.5/pppd/options.c ./pppd/options.c
--- ../ppp-2.4.5/pppd/options.c	2019-01-10 23:58:40.681572920 +0100
+++ ./pppd/options.c	2019-01-10 23:44:12.437478841 +0100
@@ -110,6 +110,7 @@
 bool	log_default = 1;	/* log_to_fd is default (stdout) */
 int	maxfail = 10;		/* max # of unsuccessful connection attempts */
 char	linkname[MAXPATHLEN];	/* logical name for link */
+char	myip[MAXNAMELEN];	/* my ip address */
 bool	tune_kernel;		/* may alter kernel settings */
 int	connect_delay = 1000;	/* wait this many ms after connect script */
 int	req_unit = -1;		/* requested interface unit */
@@ -254,6 +255,9 @@
     { "nologfd", o_int, &log_to_fd,
       "Don't send log messages to any file descriptor",
       OPT_PRIOSUB | OPT_ALIAS | OPT_NOARG | OPT_VAL(-1) },
+    { "myip", o_string, myip,
+     "Set my IP address",
+      OPT_PRIO | OPT_PRIV | OPT_STATIC, NULL, MAXNAMELEN},
 
     { "linkname", o_string, linkname,
       "Set logical name for link",
diff -Naru ../ppp-2.4.5/pppd/plugins/radius/ip_util.c ./pppd/plugins/radius/ip_util.c
--- ../ppp-2.4.5/pppd/plugins/radius/ip_util.c	2009-11-16 23:26:07.000000000 +0100
+++ ./pppd/plugins/radius/ip_util.c	2019-01-10 23:45:21.698326832 +0100
@@ -124,6 +124,9 @@
 
 UINT4 rc_own_ipaddress(void)
 {
+	if (myip != NULL)
+		return htonl(inet_addr(myip));
+
 	static UINT4 this_host_ipaddr = 0;
 
 	if (!this_host_ipaddr) {
diff -Naru ../ppp-2.4.5/pppd/pppd.h ./pppd/pppd.h
--- ../ppp-2.4.5/pppd/pppd.h	2019-01-10 23:58:40.682572918 +0100
+++ ./pppd/pppd.h	2019-01-10 23:46:35.281165339 +0100
@@ -309,6 +309,7 @@
 extern bool	sync_serial;	/* Device is synchronous serial device */
 extern int	maxfail;	/* Max # of unsuccessful connection attempts */
 extern char	linkname[MAXPATHLEN]; /* logical name for link */
+extern char     myip[MAXNAMELEN];
 extern bool	tune_kernel;	/* May alter kernel settings as necessary */
 extern int	connect_delay;	/* Time to delay after connect script */
 extern int	max_data_rate;	/* max bytes/sec through charshunt */
